'use strict';

var web = require('solid-js/web');
var solidJs = require('solid-js');
var solidQuery = require('@tanstack/solid-query');
var queryDevtools = require('@tanstack/query-devtools');

var __defProp = Object.defineProperty;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __esm = (fn, res) => function __init() {
  return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};

// src/devtools.tsx
var devtools_exports = {};
__export(devtools_exports, {
  clientOnly: () => clientOnly,
  default: () => SolidQueryDevtools
});
function SolidQueryDevtools(props) {
  const queryClient = solidQuery.useQueryClient();
  const client = solidJs.createMemo(() => props.client || queryClient);
  let ref;
  const devtools = new queryDevtools.TanstackQueryDevtools({
    client: client(),
    queryFlavor: "Solid Query",
    version: "5",
    onlineManager: solidQuery.onlineManager,
    buttonPosition: props.buttonPosition,
    position: props.position,
    initialIsOpen: props.initialIsOpen,
    errorTypes: props.errorTypes,
    styleNonce: props.styleNonce,
    shadowDOMTarget: props.shadowDOMTarget
  });
  solidJs.createEffect(() => {
    devtools.setClient(client());
  });
  solidJs.createEffect(() => {
    const buttonPos = props.buttonPosition;
    if (buttonPos) {
      devtools.setButtonPosition(buttonPos);
    }
  });
  solidJs.createEffect(() => {
    const pos = props.position;
    if (pos) {
      devtools.setPosition(pos);
    }
  });
  solidJs.createEffect(() => {
    devtools.setInitialIsOpen(props.initialIsOpen || false);
  });
  solidJs.createEffect(() => {
    devtools.setErrorTypes(props.errorTypes || []);
  });
  solidJs.onMount(() => {
    devtools.mount(ref);
    solidJs.onCleanup(() => devtools.unmount());
  });
  return (() => {
    var _el$ = _tmpl$();
    var _ref$ = ref;
    typeof _ref$ === "function" ? web.use(_ref$, _el$) : ref = _el$;
    return _el$;
  })();
}
function clientOnly(fn) {
  if (web.isServer)
    return (props) => props.fallback;
  const [comp, setComp] = solidJs.createSignal();
  fn().then((m) => setComp(() => m.default));
  return (props) => {
    let Comp;
    let m;
    const [, rest] = solidJs.splitProps(props, ["fallback"]);
    if ((Comp = comp()) && !solidJs.sharedConfig.context)
      return Comp(rest);
    const [mounted, setMounted] = solidJs.createSignal(!solidJs.sharedConfig.context);
    solidJs.onMount(() => setMounted(true));
    return solidJs.createMemo(() => (Comp = comp(), m = mounted(), solidJs.untrack(() => Comp && m ? Comp(rest) : props.fallback)));
  };
}
var _tmpl$;
var init_devtools = __esm({
  "src/devtools.tsx"() {
    _tmpl$ = /* @__PURE__ */ web.template(`<div class=tsqd-parent-container>`);
  }
});

// src/index.tsx
init_devtools();
exports.SolidQueryDevtools = web.isDev ? clientOnly(() => Promise.resolve().then(() => (init_devtools(), devtools_exports))) : function() {
  return null;
};
